/**
 * This module contains utilities for reading salve's internal schema format.
 *
 * @author Louis-Dominique Dubeau
 * @license MPL 2.0
 * @copyright Mangalam Research Center for Buddhist Languages
 */
import { Grammar } from "../patterns";
/**
 * Constructs a tree of patterns from the data structure produced by running
 * ``salve-convert`` on an RNG file.
 *
 * @param code The JSON representation (a string) or the deserialized JSON. **If
 * you pass an object, it will be mutated while producing the result.** So you
 * cannot pass the same object twice to this function. Note that if you are
 * calling this function on the same input repeatedly, you are probably "doing
 * it wrong". You should be caching the results rather than building multiple
 * identical trees.
 *
 * @throws {Error} When the version of the data is not supported.
 *
 * @returns The tree.
 */
export declare function readTreeFromJSON(code: string | {}): Grammar;
